&ANALYZE-SUSPEND _VERSION-NUMBER AB_v9r12 GUI ADM2
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME wWin
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS wWin 
/*------------------------------------------------------------------------

  File: w-systray.w
        example to run a window in the windows systray.
        requires MsgBlaster OCX
        
        20-1-2000 Rob den Boer

  Description: from cntnrwin.w - ADM SmartWindow Template

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  History: New V9 Version - January 15, 1998
          
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AB.              */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

{ windows.i }

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE SmartWindow
&Scoped-define DB-AWARE no

&Scoped-define ADM-CONTAINER WINDOW

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME fMain

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS RECT-1 FIL-MSG-WMSG FIL-MSG FIL-WPARAM-WMSG ~
FIL-WPARAM fil-lparam FIL-LPARAM-WMSG fil-retval 
&Scoped-Define DISPLAYED-OBJECTS FIL-MSG-WMSG FIL-MSG FIL-WPARAM-WMSG ~
FIL-WPARAM fil-lparam FIL-LPARAM-WMSG fil-retval 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD fn-wm-message wWin 
FUNCTION fn-wm-message RETURNS CHARACTER
   ( INPUT piMsg AS INTEGER )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR wWin AS WIDGET-HANDLE NO-UNDO.

/* Menu Definitions                                                     */
DEFINE MENU systray-popup 
       MENU-ITEM m_Configure_this LABEL "Configure this"
       MENU-ITEM m_Options_that LABEL "Options that"  
       MENU-ITEM m_Something_else LABEL "Something else"
       RULE
       MENU-ITEM m_Exit         LABEL "Exit"          .


/* Definitions of handles for OCX Containers                            */
DEFINE VARIABLE CtrlFrame AS WIDGET-HANDLE NO-UNDO.
DEFINE VARIABLE chCtrlFrame AS COMPONENT-HANDLE NO-UNDO.
DEFINE VARIABLE CtrlFrame-2 AS WIDGET-HANDLE NO-UNDO.
DEFINE VARIABLE chCtrlFrame-2 AS COMPONENT-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE VARIABLE fil-lparam AS CHARACTER FORMAT "X(256)":U 
     LABEL "lparam" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

DEFINE VARIABLE FIL-LPARAM-WMSG AS CHARACTER FORMAT "X(256)":U 
     VIEW-AS FILL-IN 
     SIZE 30.6 BY 1 NO-UNDO.

DEFINE VARIABLE FIL-MSG AS CHARACTER FORMAT "X(256)":U 
     LABEL "MsgVal" 
     VIEW-AS FILL-IN 
     SIZE 14.2 BY 1 NO-UNDO.

DEFINE VARIABLE FIL-MSG-WMSG AS CHARACTER FORMAT "X(256)":U 
     VIEW-AS FILL-IN 
     SIZE 30.6 BY 1 NO-UNDO.

DEFINE VARIABLE fil-retval AS CHARACTER FORMAT "X(256)":U 
     LABEL "retval" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

DEFINE VARIABLE FIL-WPARAM AS CHARACTER FORMAT "X(256)":U 
     LABEL "Wparam" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

DEFINE VARIABLE FIL-WPARAM-WMSG AS CHARACTER FORMAT "X(256)":U 
     VIEW-AS FILL-IN 
     SIZE 30.6 BY 1 NO-UNDO.

DEFINE RECTANGLE RECT-1
     EDGE-PIXELS 2 GRAPHIC-EDGE  NO-FILL 
     SIZE 69 BY 8.33.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME fMain
     FIL-MSG-WMSG AT ROW 6.71 COL 34 COLON-ALIGNED NO-LABEL
     FIL-MSG AT ROW 6.81 COL 13.8 COLON-ALIGNED
     FIL-WPARAM-WMSG AT ROW 7.95 COL 34 COLON-ALIGNED NO-LABEL
     FIL-WPARAM AT ROW 8 COL 13.8 COLON-ALIGNED
     fil-lparam AT ROW 9.19 COL 13.8 COLON-ALIGNED
     FIL-LPARAM-WMSG AT ROW 9.19 COL 34 COLON-ALIGNED NO-LABEL
     fil-retval AT ROW 10.38 COL 13.8 COLON-ALIGNED
     "Debug WM Messages" VIEW-AS TEXT
          SIZE 22 BY .71 AT ROW 3.62 COL 4
     "WM Message" VIEW-AS TEXT
          SIZE 20.2 BY .62 AT ROW 5.48 COL 36
     RECT-1 AT ROW 3.86 COL 2
     "Press Minimize to go to Systray" VIEW-AS TEXT
          SIZE 31 BY .62 AT ROW 1.48 COL 24
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 71.2 BY 11.81.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: SmartWindow
   Allow: Basic,Browse,DB-Fields,Query,Smart,Window
   Container Links: Data-Target,Data-Source,Page-Target
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW wWin ASSIGN
         HIDDEN             = YES
         TITLE              = "Systray Example"
         HEIGHT             = 11.81
         WIDTH              = 71.2
         MAX-HEIGHT         = 34.33
         MAX-WIDTH          = 204.8
         VIRTUAL-HEIGHT     = 34.33
         VIRTUAL-WIDTH      = 204.8
         RESIZE             = no
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB wWin 
/* ************************* Included-Libraries *********************** */

{src/adm2/containr.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME




/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW wWin
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME fMain
                                                                        */
ASSIGN 
       FRAME fMain:POPUP-MENU       = MENU systray-popup:HANDLE.

IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(wWin)
THEN wWin:HIDDEN = yes.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 


/* **********************  Create OCX Containers  ********************** */

&ANALYZE-SUSPEND _CREATE-DYNAMIC

&IF "{&OPSYS}" = "WIN32":U AND "{&WINDOW-SYSTEM}" NE "TTY":U &THEN

CREATE CONTROL-FRAME CtrlFrame-2 ASSIGN
       FRAME        = FRAME fMain:HANDLE
       ROW          = 1.24
       COLUMN       = 3
       HEIGHT       = 1.33
       WIDTH        = 5.6
       HIDDEN       = yes
       SENSITIVE    = yes.

CREATE CONTROL-FRAME CtrlFrame ASSIGN
       FRAME        = FRAME fMain:HANDLE
       ROW          = 1.24
       COLUMN       = 64
       HEIGHT       = 1.43
       WIDTH        = 6
       HIDDEN       = yes
       SENSITIVE    = yes.

PROCEDURE adm-create-controls:
      CtrlFrame-2:NAME = "CtrlFrame-2":U .
/* CtrlFrame-2 OCXINFO:CREATE-CONTROL from: {F0B88A90-F5DA-11CF-B545-0020AF6ED35A} type: PSTimer */
      CtrlFrame:NAME = "CtrlFrame":U .
/* CtrlFrame OCXINFO:CREATE-CONTROL from: {3E0E9324-C743-11D0-8A5E-0020AFEEAE87} type: Msgblst32 */
      CtrlFrame:MOVE-AFTER(CtrlFrame-2).

END PROCEDURE.

&ENDIF

&ANALYZE-RESUME /* End of _CREATE-DYNAMIC */


/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME wWin
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL wWin wWin
ON END-ERROR OF wWin /* Systray Example */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL wWin wWin
ON WINDOW-CLOSE OF wWin /* Systray Example */
DO:
   RUN ip-systray-exit. 

  /* This ADM code must be left here in order for the SmartWindow
     and its descendents to terminate properly on exit. */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL wWin wWin
ON WINDOW-MINIMIZED OF wWin /* Systray Example */
DO:
    /* on minimize, this will add to systray the first time,
       subsequent calls will rotate through the iconlist for animation */
       
    RUN ip-next-icon.
    {&WINDOW-NAME}:VISIBLE = FALSE.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME CtrlFrame
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL CtrlFrame wWin OCX.Message
PROCEDURE CtrlFrame.Msgblst32.Message .
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  Required for OCX.
    MsgVal
    wParam
    lParam
    lplRetVal
  Notes:       
------------------------------------------------------------------------------*/

DEFINE INPUT        PARAMETER p-MsgVal    AS INTEGER NO-UNDO.
DEFINE INPUT        PARAMETER p-wParam    AS INTEGER NO-UNDO.
DEFINE INPUT        PARAMETER p-lParam    AS INTEGER NO-UNDO.
DEFINE INPUT-OUTPUT PARAMETER p-lplRetVal AS INTEGER NO-UNDO.


DO WITH FRAME {&FRAME-NAME}:

  /* --- the right click on our systray icon -- */
  IF p-MsgVal = {&WM_LBUTTONDOWN} AND p-lParam = {&WM_RBUTTONDOWN}
  THEN DO:
    RUN SetForegroundWindow (INPUT SELF:HWND).
    RUN SendMessageA (INPUT SELF:HWND,          /* simulate mouseclick for popup */
                      INPUT {&WM_RBUTTONDOWN},    
                      INPUT 0,
                      INPUT 0).
    RUN SendMessageA (INPUT SELF:HWND,
                      INPUT {&WM_RBUTTONUP},    
                      INPUT 0,
                      INPUT 0).
  END. /* IF */                         
  
  /* --- the left click on our systray icon --- */
  IF p-MsgVal = {&WM_LBUTTONDOWN} AND p-lParam = {&WM_LBUTTONDOWN}
  THEN  ASSIGN {&WINDOW-NAME}:VISIBLE      = TRUE
               {&WINDOW-NAME}:WINDOW-STATE = 3.

  /* show me those wm messages ... */
  ASSIGN  FIL-MSG:SCREEN-VALUE         = STRING(p-MsgVal)
          FIL-MSG-WMSG:SCREEN-VALUE    = fn-wm-message(p-MsgVal)
          FIL-WPARAM:SCREEN-VALUE      = STRING(p-wParam)
          FIL-WPARAM-WMSG:SCREEN-VALUE = fn-wm-message(p-wParam)
          FIL-LPARAM:SCREEN-VALUE      = STRING(p-lParam)
          FIL-LPARAM-WMSG:SCREEN-VALUE = fn-wm-message(p-lParam)
          FIL-RETVAL:SCREEN-VALUE      = STRING(p-lplRetVal)
          .

END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME CtrlFrame-2
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL CtrlFrame-2 wWin OCX.Tick
PROCEDURE CtrlFrame-2.PSTimer.Tick .
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  None required for OCX.
  Notes:       
------------------------------------------------------------------------------*/
    /* animate those icons while sitting in the systray */
    
    IF {&WINDOW-NAME}:WINDOW-STATE = 2
    THEN  RUN ip-next-icon.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Exit
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Exit wWin
ON CHOOSE OF MENU-ITEM m_Exit /* Exit */
DO:
  RUN exitObject.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK wWin 


/* ***************************  Main Block  *************************** */

/* Include custom  Main Block code for SmartWindows. */
{src/adm2/windowmn.i}

{ s-systray.i }

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects wWin  _ADM-CREATE-OBJECTS
PROCEDURE adm-create-objects :
/*------------------------------------------------------------------------------
  Purpose:     Create handles for all SmartObjects used in this procedure.
               After SmartObjects are initialized, then SmartLinks are added.
  Parameters:  <none>
------------------------------------------------------------------------------*/

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE control_load wWin  _CONTROL-LOAD
PROCEDURE control_load :
/*------------------------------------------------------------------------------
  Purpose:     Load the OCXs    
  Parameters:  <none>
  Notes:       Here we load, initialize and make visible the 
               OCXs in the interface.                        
------------------------------------------------------------------------------*/

&IF "{&OPSYS}" = "WIN32":U AND "{&WINDOW-SYSTEM}" NE "TTY":U &THEN
DEFINE VARIABLE UIB_S    AS LOGICAL    NO-UNDO.
DEFINE VARIABLE OCXFile  AS CHARACTER  NO-UNDO.

OCXFile = SEARCH( "w-systray.wrx":U ).
IF OCXFile = ? THEN
  OCXFile = SEARCH(SUBSTRING(THIS-PROCEDURE:FILE-NAME, 1,
                     R-INDEX(THIS-PROCEDURE:FILE-NAME, ".":U), "CHARACTER":U) + "wrx":U).

IF OCXFile <> ? THEN
DO:
  ASSIGN
    chCtrlFrame = CtrlFrame:COM-HANDLE
    UIB_S = chCtrlFrame:LoadControls( OCXFile, "CtrlFrame":U)
    chCtrlFrame-2 = CtrlFrame-2:COM-HANDLE
    UIB_S = chCtrlFrame-2:LoadControls( OCXFile, "CtrlFrame-2":U)
  .
  RUN initialize-controls IN THIS-PROCEDURE NO-ERROR.
END.
ELSE MESSAGE "w-systray.wrx":U SKIP(1)
             "The binary control file could not be found. The controls cannot be loaded."
             VIEW-AS ALERT-BOX TITLE "Controls Not Loaded".

&ENDIF

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI wWin  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(wWin)
  THEN DELETE WIDGET wWin.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI wWin  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY FIL-MSG-WMSG FIL-MSG FIL-WPARAM-WMSG FIL-WPARAM fil-lparam 
          FIL-LPARAM-WMSG fil-retval 
      WITH FRAME fMain IN WINDOW wWin.
  ENABLE RECT-1 FIL-MSG-WMSG FIL-MSG FIL-WPARAM-WMSG FIL-WPARAM fil-lparam 
         FIL-LPARAM-WMSG fil-retval 
      WITH FRAME fMain IN WINDOW wWin.
  {&OPEN-BROWSERS-IN-QUERY-fMain}
  VIEW wWin.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE exitObject wWin 
PROCEDURE exitObject :
/*------------------------------------------------------------------------------
  Purpose:  Window-specific override of this procedure which destroys 
            its contents and itself.
    Notes:  
------------------------------------------------------------------------------*/

  RUN ip-systray-exit.

  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initializeObject wWin 
PROCEDURE initializeObject :
/*------------------------------------------------------------------------------
  Purpose:     Super Override
  Parameters:  
  Notes:       
------------------------------------------------------------------------------*/

  /* Code placed here will execute PRIOR to standard behavior. */

  RUN SUPER.

  /* Code placed here will execute AFTER standard behavior.    */
  
  RUN ip-systray-init(INPUT 123,    /* some unique ID for your systray app */
                      INPUT "moon01.ico,moon02.ico,moon03.ico,moon04.ico,moon05.ico,moon06.ico,moon07.ico,moon08.ico",
                      INPUT "Put your Tooltip on top of the moon-eclipse ...").

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

/* ************************  Function Implementations ***************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION fn-wm-message wWin 
FUNCTION fn-wm-message RETURNS CHARACTER
   ( INPUT piMsg AS INTEGER ) :
/*------------------------------------------------------------------------------
  Purpose:  returns descr. of a windows message no.
    Notes:  
------------------------------------------------------------------------------*/
  
  DEFINE VARIABLE cMsg AS CHARACTER NO-UNDO.
  DEFINE VARIABLE cTxt AS CHARACTER NO-UNDO.
  DEFINE VARIABLE iTmp AS INTEGER NO-UNDO.
  
  ASSIGN cTxt = "WM_LBUTTONDBLCLK,WM_LBUTTONDOWN,WM_LBUTTONUP,WM_MBUTTONDBLCLK,WM_MBUTTONDOWN,WM_MBUTTONUP,WM_RBUTTONDBLCLK,WM_RBUTTONDOWN,WM_RBUTTONUP"
         cMsg = "515,513,514,521,519,520,518,516,517"
         iTmp = LOOKUP(STRING(piMsg), cMsg)
                  .
  IF iTmp = 0
  THEN RETURN "unknown".
  ELSE RETURN ENTRY(iTmp,cTxt).

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

